package be.iminds.ilabt.jfed.experimenter_gui.slice;

import be.iminds.ilabt.jfed.highlevel.model.Slice;
import be.iminds.ilabt.jfed.highlevel.model.Sliver;

import javax.annotation.Nonnull;
import java.time.Instant;

/**
 * User: twalcari
 * Date: 8/14/2015
 * Time: 10:38
 */
public class NextExperimentExpiration {

    private final Sliver firstExpiringSliver;
    private final Instant firstExpirationTime;

    private final boolean hasPartExpired;


    public NextExperimentExpiration(@Nonnull Slice slice) {
        Sliver firstExpiringSliver = null;
        Instant firstExpirationTime = slice.getExpirationDate();
        boolean hasPartExpired = firstExpirationTime != null && firstExpirationTime.isBefore(Instant.now());


        for (Sliver sliver : slice.getSlivers()) {
            if (sliver.getExpirationDate() == null)
                continue;

            if (sliver.getExpirationDate().isBefore(Instant.now())) {
                hasPartExpired = true;
            } else if (firstExpirationTime == null || sliver.getExpirationDate().isBefore(firstExpirationTime)) {
                firstExpiringSliver = sliver;
                firstExpirationTime = sliver.getExpirationDate();
            }
        }

        this.firstExpirationTime = firstExpirationTime;
        this.firstExpiringSliver = firstExpiringSliver;
        this.hasPartExpired = hasPartExpired;
    }

    public Instant getFirstExpirationTime() {
        return firstExpirationTime;
    }

    public Sliver getFirstExpiringSliver() {
        return firstExpiringSliver;
    }

    public boolean hasPartExpired() {
        return hasPartExpired;
    }
}
