package be.iminds.ilabt.jfed.experimenter_gui.slice.tasks;

import be.iminds.ilabt.jfed.experimenter_gui.slice.Experiment;
import be.iminds.ilabt.jfed.highlevel.controller.Task;
import be.iminds.ilabt.jfed.highlevel.tasks.HighLevelTaskFactory;
import be.iminds.ilabt.jfed.lowlevel.authority.SfaAuthority;

/**
 * User: twalcari
 * Date: 2/2/2015
 * Time: 17:24
 */
public class StopExperimentAtAuthorityTask extends SingleCallExperimentTask {

    private final SfaAuthority authority;

    StopExperimentAtAuthorityTask(Experiment experiment, SfaAuthority authority, HighLevelTaskFactory hltf) {
        super(experiment, hltf);
        this.authority = authority;
        assert (experiment.getSlice() != null);

        updateTitle("Release all resources on " + authority.getHrn() + " of experiment '" + experiment.getName() + "'");
    }


    @Override
    public Task createTask() {
        return hltf.deleteSliversAtAuthority(experiment.getSlice(), authority);
    }


//    @Override
//    public void onTaskStarting() {
//        Platform.runLater(() -> {
//            experiment.setDeleting(true);
//        });
//    }
//
//
//    @Override
//    public void onTaskFinished(TaskExecution taskExecution) {
//        if (taskExecution.getState() == TaskExecution.TaskState.SUCCESS) {
//            assert (experiment.getExperimentRestoreInformation() != null);
//            experiment.getExperimentRestoreInformation().delete();
//        } else {
//            //deletion failed!
//            experiment.setDeleting(false);
//        }
//    }
}
