package be.iminds.ilabt.jfed.experimenter_gui.slice.tasks;

import be.iminds.ilabt.jfed.experimenter_gui.slice.Experiment;
import be.iminds.ilabt.jfed.highlevel.controller.Task;
import be.iminds.ilabt.jfed.highlevel.controller.TaskExecution;
import be.iminds.ilabt.jfed.highlevel.tasks.HighLevelTaskFactory;

/**
 * User: twalcari
 * Date: 2/2/2015
 * Time: 17:24
 */
public class StopExperimentTask extends SingleCallExperimentTask {

    StopExperimentTask(Experiment experiment, HighLevelTaskFactory hltf) {
        super(experiment, hltf);
        assert(experiment.getSlice() != null);

        updateTitle("Delete all active nodes from experiment '" + experiment.getName() + "'");
    }

    @Override
    public Task createTask() {
        return hltf.deleteSlice(experiment.getSlice());
    }

    @Override
    public void onTaskFinished(TaskExecution taskExecution) {
        if (taskExecution.getState() == TaskExecution.TaskState.SUCCESS) {
            assert (experiment.getExperimentRestoreInformation() != null);
            experiment.getExperimentRestoreInformation().delete();
        }
    }
}
