package be.iminds.ilabt.jfed.highlevel.jobs;

import com.google.common.util.concurrent.ThreadFactoryBuilder;

import javax.inject.Inject;
import javax.inject.Singleton;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

/**
 * User: twalcari
 * Date: 7/13/2015
 * Time: 16:43
 */
@Singleton
public class JobExecutor {

    private final ExecutorService executorService = Executors.newCachedThreadPool(
            new ThreadFactoryBuilder().setNameFormat("JobExecutor-%d").build());

    @Inject public JobExecutor(){}


    public <V> Future<V> submitJob(Job<V> job) {
        return executorService.submit(job);
    }

}
